/* *************************************************************************
                         lightlist.cpp  -  description
                             -------------------
    begin                : Wed Oct 16 2002        
    copyright            : (C) 2002 by Micha Riser
    email                : mriser@gmx.net
 ************************************************************************* */

/* *************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ************************************************************************* */

#include "lightlist.h"

LightList* LightList::merge(LightList* first, const LightList* second, DBL weight) {

    if (second == 0) return first;

    if (first == 0) {
        LightList* ret = 0;
        // Copy second and scale it by weight
        while(second != 0) {

            LightList* old = ret;
            ret = new LightList(*second);
            ret->colour.scale(weight);
            ret->next = old;
            second = second->next;

        }

        return ret;

    } else {

        while(second != 0) {

            // Search if LightSource is already in list
            LightList* it = first;
            while(it != 0) {
                
                if (it->light == second->light) {
                    // add weighted colour
                    it->colour.add(second->colour.scaled(weight));
                    break;         
                } 

                if (it->next == 0) {
                    // Create new entry in list
                    it->next = new LightList(*second);
                    it->next->colour.scale(weight);
                    it->next->next = 0;
                    break;
                }

                it = it->next;
            }
            
            second = second->next;

        }

        return first;

    }

}
