/* *************************************************************************
                          pattern.cpp  -  description
                             -------------------
    begin                : Fri Oct 18 2002
    copyright            : (C) 2002 by Micha Riser
    email                : mriser@gmx.net
 ************************************************************************* */

/* *************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ************************************************************************* */

#include "pattern.h"

const DBL Pattern::SPACE_EPSILON = 1e-10;

FLT Checker::evaluateAt(const Vector3& v) const {

    int ret = 0;
    for(int i=0; i<3; i++) ret = ret + (int)floor(v.a[i]+SPACE_EPSILON);
    if (ret % 2) return 1.0; else return 0.0;
  
}

Pattern* Checker::copy() const {
    return new Checker(*this);
}

FLT Gradient::evaluateAt(const Vector3& v) const {

    double ret = Vector3::dotProd(v,gradient);
    return ret - floor(ret);

}

Pattern* Gradient::copy() const {
    return new Gradient(*this);
}

