/* *************************************************************************
                          pointlight.h  -  description
                             -------------------
    begin                : Wed Oct 16 2002    
    copyright            : (C) 2002 by Micha Riser
    email                : mriser@gmx.net
 ************************************************************************* */

/* *************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ************************************************************************* */

#ifndef POINTLIGHT_H
#define POINTLIGHT_H

#include "lightsource.h"
#include "lightcache.h"

/**Point light. Light with no dimension.
  *@author Micha Riser
  */

class PointLight: public LightSource  {
  
private: // Private attributes
    Colour3 c;
    Scene* scene;
  
public: // Constructors and destructor
    PointLight(const Vector3& location, const Colour3& col, Scene* s):
      LightSource(location), c(col), scene(s)/*, cache(this,s)*/ {}

    ~PointLight() {}

public: // Public methods

    // Inherited by LightSource
    LightRay shineTo(const Vector3& to, InsideList* l) const;
    Colour3 enlight(const CameraRay& cray, const Texture* t, InsideList* l) const;
    
};

#endif
